package com.usky.dxtop.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.usky.dxtop.mapper.MsgLogMapper;
import com.usky.dxtop.model.MsgLog;
import com.usky.dxtop.service.MsgLogService;
import com.usky.dxtop.service.emun.MsgLogStatus;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author yq
 * @since 2021-10-13
 */
@Slf4j
@Service
public class MsgLogServiceImpl extends ServiceImpl<MsgLogMapper, MsgLog> implements MsgLogService {

    @Override
    public Boolean isRepetition(MsgLog msgLog) {
        return !(null == msgLog || msgLog.getMsgFlag().equals(MsgLogStatus.CONSUMER_SUCCESS.getCode()));
    }

    @Override
    public void consumerSuccess(String consequence) {
        JSONObject jsonObject = JSONObject.parseObject(consequence);
        Long msgId = Long.parseLong(jsonObject.get("seq").toString());
        MsgLog msgLog = this.getById(msgId);
        if (this.isRepetition(msgLog)){
            if ("1".equals(jsonObject.get("code").toString())){
                msgLog.setIsSuccess(true);
            }else {
                msgLog.setIsSuccess(false);
            }
            msgLog.setConsequence(consequence);
            msgLog.setMsgFlag(MsgLogStatus.CONSUMER_SUCCESS.getCode());
            this.updateById(msgLog);
        }
    }

    @Override
    public boolean isSuccess(Long businessId) {
        LambdaQueryWrapper<MsgLog> queryWrapper = Wrappers.lambdaQuery();
        queryWrapper.eq(MsgLog::getMsgFlag,MsgLogStatus.CONSUMER_SUCCESS.getCode())
                .eq(MsgLog::getIsSuccess,true)
                .eq(MsgLog::getBusinessId,businessId);
        int count = this.count(queryWrapper);
        if (count > 0){
            return true;
        }else {
            return false;
        }
    }

}
